/* 
 * DissolveView.m created by fedor on 2002-01-08 16:12:41 -0700
 *
 * Project DisplayTesting
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: class.template,v 1.2 2001/12/28 13:46:11 probert Exp $
 */

#import "DissolveView.h"
#include <math.h>

#define INTERVALS 40.0

@implementation DissolveView

- (void) setImageName: sender
{
  int result;
  NSArray *fileTypes;
  NSOpenPanel *oPanel = [NSOpenPanel openPanel];

  fileTypes = [NSArray arrayWithObjects: @"tiff", @"tif", @"pgm", @"gif", @"jpg", nil];
  [oPanel setAllowsMultipleSelection: NO];
  [oPanel setCanChooseFiles: YES];
  [oPanel setCanChooseDirectories: NO];
  result = [oPanel runModalForDirectory: nil
				   file: nil
				  types: fileTypes];
  if (result == NSOKButton)
    {
      NSImage *newImage;
      NSString *name = [oPanel filename];
      newImage = [[NSImage alloc] initWithContentsOfFile: name];
      AUTORELEASE(newImage);
      if (newImage)
	ASSIGN(image, newImage);
    }
}

- (void) setupTimer
{
  if (timer)
    return;
  
  if (period == 0)
    period = 10;

  timer = [NSTimer scheduledTimerWithTimeInterval: period/INTERVALS
		   target: self
		   selector: @selector(display)
		   userInfo: nil
		   repeats: YES];
  RETAIN(timer);
}

- (void) setPeriod: sender
{
  period = [sender floatValue];
  if (period < 1)
    period = 1;
  if (period > 30)
    period = 30;

  if (timer)
    {
      [timer invalidate];
      DESTROY(timer);
    }
  [self setupTimer];
}

- (void) drawRect: (NSRect)rect
{
  if (timer == nil)
    [self setupTimer];

  if (image == nil)
    {
      image = RETAIN([NSImage imageNamed: @"GNUstep.tiff"]);
    }

  [image dissolveToPoint: NSMakePoint(0,0) fraction: fabs(fraction)];

  fraction += (1/INTERVALS);
  if (fraction > 1)
    fraction = -1;
}

@end
